<template>
  <div class="row justify-content-center img-bg">
    <div class="absolute row">
      <div class="col-2"></div>
      <div class="col-8 row main-contain auth-custom-contain">
        <div
          class="col-7 left-contain-on-border bg-white text-center overflow-main-contain scrollbar"
        >
          <div class="space-2" />
          <h4 class="t-color-soft-gray font-variant-caps">{{title1}}</h4>
          <h1 class="t-color-red">{{title2}}</h1>
          <p class="t-color-soft-gray">{{dialog1}}</p>
          <div class="row">
            <div class="col-2" />
            <div class="col-8">
              <form>
                <div class="group">
                  <input type="text" v-model="email" required="required" />
                  <span class="highlight"></span>
                  <span class="bar"></span>
                  <label>{{text1}}</label>
                  <div class="row absolute">
                    <h6 v-if="email === ''" class="t-validate-div t-color-red col-12 right">
                      <i class="fa fa-exclamation-circle" /> Email is required
                    </h6>
                    <h6
                      v-if="(email !=='') && (!reg.test(email))"
                      class="t-validate-div t-color-red col-12 right"
                    >
                      <i class="fa fa-times-circle" /> Please Enter Correct Email
                    </h6>
                  </div>
                </div>
                <div class="group pass_show">
                  <input type="password" v-model="password" id="password-field" required="required" />
                  <span class="highlight"></span>
                  <span class="bar"></span>
                  <label>{{text2}}</label>
                  <div class="row absolute">
                    <h6 v-if="password === ''" class="t-validate-div t-color-red col-12 right">
                      <i class="fa fa-exclamation-circle" /> Password is required
                    </h6>
                    <h6
                      v-if="(password.length > 0) && (password.length < 6)"
                      class="t-validate-div t-color-red col-12 right"
                    >
                      <i class="fa fa-times-circle" />Password must have at least 6 characters
                    </h6>
                  </div>
                </div>
                <botton class="btn" v-on:click="signin">{{text3}}</botton>
                <router-link to="/forgotpass" class="link">{{text4}}</router-link>
                <div class="space-2" />
                <h6 class="t-color-soft-gray">
                  {{text5}}
                  <router-link to="/signup" class="link">{{text6}}</router-link>
                </h6>
              </form>
            </div>
            <div class="col-2" />
          </div>
        </div>
        <div class="col-5 right-contain-on-border img-auth-bg"></div>
      </div>
    </div>
     <b-alert
      :show="dismissCountDown"
      variant="danger"
      @dismissed="dismissCountDown=0"
      @dismiss-count-down="countDownChanged"
      fade
      style="position: absolute;top: 1px;width: auto;"
    >
    <i class="fa fa-check-circle"/> {{massage}}
    </b-alert>
    <b-alert
      :show="validateEmail"
      variant="warning"
      @dismissed="ValiCountDown=0"
      @dismiss-count-down="ValiCountDownChanged"
      fade
      class="alert-top"
    >
    <i class="fa fa-exclamation-circle"/> Please check your email or <a class="t-color-red" @click="sendMailAgain">send again</a> to validate
    </b-alert>
    <b-alert
      :show="validateEmailSuc"
      variant="success"
      @dismissed="ValiSucCountDownSuc=0"
      @dismiss-count-down="ValiSucCountDownChanged"
      fade
      class="alert-top"
    >
    <i class="fa fa-check-circle"/> {{massage}}
    </b-alert>
  </div>
</template>

<script>
// import VueCookie from 'vue-cookie'
export default {
  mounted () {
    console.log('Component mounted.')
  },
  data () {
    return {
      title1: 'WELCOME TO',
      title2: 'Project Management',
      dialog1: 'Login to use the intelligent program',
      text1: 'Email',
      text2: 'Password',
      text3: 'SIGN IN',
      text4: 'Forgot Password',
      text5: "Don't have an account?",
      text6: 'Sign up',
      email: '',
      password: '',
      cookie: this.$cookie,
      massage: '',
      validateEmail: 0,
      validateEmailSuc: 0,
      dismissSecs: 3,
      dismissCountDown: 0,
      ValiCountDown: 0,
      ValiSucCountDownSuc: 0,
      reg: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,24}))$/
    }
  },
  methods: {
    signin: function (e) {
      e.preventDefault()
      this.axios
        .post('http://127.0.0.1:8000/api/signin', {
          email: this.email,
          password: this.password
        })
        .then(response => {
          this.$cookie.set('token', response.data.token)
          this.$cookie.set('role', response.data.getUser.role)
          this.$cookie.set('username', response.data.getUser.username)
          this.$cookie.set('id', response.data.getUser.id)
          if (response.data.getUser.emailConfirmation === 'N') {
            this.$cookie.delete('token')
            this.$cookie.delete('role')
            this.$cookie.delete('username')
            this.$cookie.delete('id')
            this.showAlertEmail()
          } else {
            if (!response.data.getUser.confirmMailToken) {
              if (response.data.getUser.role === 'Admin') {
                this.$router.push('/')
              } else {
                this.$router.push('/ProjectBlockList')
              }
            } else {
              this.$router.push('/createPro/' + response.data.getUser.id)
              this.$cookie.set('checkMail', response.data.getUser.confirmMailToken)
            }
          }
        })
        .catch(error => {
          console.log(error)
          this.showAlertError()
        })
    },
    sendMailAgain () {
      console.log(this.email)
      this.axios
        .post('http://127.0.0.1:8000/api/sendMailConfirmationAgainInSignin', {
          email: this.email
        })
        .then(response => {
          this.showAlertSendVali()
        })
        .catch(error => {
          console.log(error)
        })
    },
    countDownChanged (dismissCountDown) {
      this.dismissCountDown = dismissCountDown
    },
    ValiCountDownChanged (dismissCountDown) {
      this.validateEmail = dismissCountDown
    },
    ValiSucCountDownChanged (dismissCountDown) {
      this.validateEmailSuc = dismissCountDown
    },
    showAlertEmail () {
      this.validateEmail = this.dismissSecs
    },
    showAlertError () {
      this.massage = ''
      this.massage = 'Your email or password is wrong'
      this.dismissCountDown = this.dismissSecs
    },
    showAlertSendVali () {
      this.massage = ''
      this.massage = 'Your validate email was send.'
      this.validateEmailSuc = this.dismissSecs
    }
  },
  computed: {
  }
}
</script>
